import { DocumentNode } from 'graphql';
import { MutationOptions, OperationVariables } from 'apollo-client';
import { FetchResult } from 'apollo-link';
import { ReactiveFunction } from './util/ReactiveFunction';
export interface UseMutationOptions<TResult = any, TVariables = OperationVariables> extends Omit<MutationOptions<TResult, TVariables>, 'mutation'> {
    clientId?: string;
}
export declare function useMutation<TResult = any, TVariables = OperationVariables>(document: DocumentNode | ReactiveFunction<DocumentNode>, options?: UseMutationOptions<TResult, TVariables> | ReactiveFunction<UseMutationOptions<TResult, TVariables>>): {
    mutate: (variables: TVariables, overrideOptions: Pick<UseMutationOptions<any, OperationVariables>, "update" | "optimisticResponse" | "context" | "updateQueries" | "refetchQueries" | "awaitRefetchQueries" | "errorPolicy" | "fetchPolicy" | "clientId">) => Promise<FetchResult<any, Record<string, any>, Record<string, any>>>;
    loading: import("@vue/composition-api").Ref<boolean>;
    error: import("@vue/composition-api").Ref<Error>;
    called: import("@vue/composition-api").Ref<boolean>;
    onDone: (fn: (param?: FetchResult<TResult, Record<string, any>, Record<string, any>>) => void) => {
        off: () => void;
    };
    onError: (fn: (param?: Error) => void) => {
        off: () => void;
    };
};
